diff --git a/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx b/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx
index dce34607..eae55dee 100644
--- a/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx
+++ b/web/pgadmin/static/jsx/history/detail/history_detail_query.jsx
@@ -64,6 +64,7 @@ export default class HistoryDetailQuery extends React.Component {
             mode: 'text/x-pgsql',
             readOnly: true,
           }}
+          sqlFontSize= {this.props.sqlEditorPref.sql_font_size}
         />
       </div>);
   }
@@ -71,4 +72,5 @@ export default class HistoryDetailQuery extends React.Component {
 
 HistoryDetailQuery.propTypes = {
   historyEntry: Shapes.historyDetail,
+  sqlEditorPref: Shapes.sqlEditorPrefObj,
 };
diff --git a/web/pgadmin/static/jsx/history/query_history.jsx b/web/pgadmin/static/jsx/history/query_history.jsx
index 3c07b5bd..8b5ffd2a 100644
--- a/web/pgadmin/static/jsx/history/query_history.jsx
+++ b/web/pgadmin/static/jsx/history/query_history.jsx
@@ -97,13 +97,16 @@ export default class QueryHistory extends React.Component {
           selectedEntry={this.state.selectedEntry}
           onSelectEntry={this.selectHistoryEntry}
         />
-        <QueryHistoryDetail historyEntry={this.state.currentHistoryDetail}/>
+        <QueryHistoryDetail historyEntry={this.state.currentHistoryDetail}
+            sqlEditorPref={this.props.sqlEditorPref}
+        />
       </SplitPane>);
   }
 }
 
 QueryHistory.propTypes = {
   historyCollection: Shapes.historyCollectionClass.isRequired,
+  sqlEditorPref: Shapes.sqlEditorPrefObj,
 };
 
 export {
diff --git a/web/pgadmin/static/jsx/react_shapes.jsx b/web/pgadmin/static/jsx/react_shapes.jsx
index 454ab446..f8948b5f 100644
--- a/web/pgadmin/static/jsx/react_shapes.jsx
+++ b/web/pgadmin/static/jsx/react_shapes.jsx
@@ -25,7 +25,13 @@ let historyCollectionClass =
     onChange: PropTypes.func.isRequired,
   });
 
+let sqlEditorPrefObj =
+  PropTypes.shape({
+    sql_font_size: PropTypes.string.isRequired,
+  });
+
 export default {
   historyDetail,
   historyCollectionClass,
+  sqlEditorPrefObj,
 };
diff --git a/web/pgadmin/tools/datagrid/__init__.py b/web/pgadmin/tools/datagrid/__init__.py
index d3c3bf9c..04e2a683 100644
--- a/web/pgadmin/tools/datagrid/__init__.py
+++ b/web/pgadmin/tools/datagrid/__init__.py
@@ -24,12 +24,9 @@ from pgadmin.utils.ajax import make_json_response, bad_request, \
     internal_server_error
 
 from config import PG_DEFAULT_DRIVER
-from pgadmin.utils.preferences import Preferences
 from pgadmin.model import Server
 from pgadmin.utils.driver import get_driver
 from pgadmin.utils.exception import ConnectionLost, SSHTunnelConnectionLost
-from pgadmin.tools.sqleditor.utils.query_tool_preferences import \
-    get_query_tool_keyboard_shortcuts, get_text_representation_of_shortcut
 
 
 class DataGridModule(PgAdminModule):
@@ -184,13 +181,9 @@ def initialize_datagrid(cmd_type, obj_type, sgid, sid, did, obj_id):
     # Store the grid dictionary into the session variable
     session['gridData'] = sql_grid_data
 
-    pref = Preferences.module('sqleditor')
-    new_browser_tab = pref.preference('new_browser_tab').get()
-
     return make_json_response(
         data={
-            'gridTransId': trans_id,
-            'newBrowserTab': new_browser_tab
+            'gridTransId': trans_id
         }
     )
 
@@ -246,12 +239,6 @@ def panel(trans_id, is_query_tool, editor_title):
     if "linux" in _platform:
         is_linux_platform = True
 
-    pref = Preferences.module('sqleditor')
-    if pref.preference('new_browser_tab').get():
-        new_browser_tab = 'true'
-    else:
-        new_browser_tab = 'false'
-
     # Fetch the server details
     bgcolor = None
     fgcolor = None
@@ -271,16 +258,10 @@ def panel(trans_id, is_query_tool, editor_title):
 
     url_params = dict()
     if is_query_tool == 'true':
-        prompt_save_changes = pref.preference(
-            'prompt_save_query_changes'
-        ).get()
         url_params['sgid'] = trans_obj.sgid
         url_params['sid'] = trans_obj.sid
         url_params['did'] = trans_obj.did
     else:
-        prompt_save_changes = pref.preference(
-            'prompt_save_data_changes'
-        ).get()
         url_params['cmd_type'] = trans_obj.cmd_type
         url_params['obj_type'] = trans_obj.object_type
         url_params['sgid'] = trans_obj.sgid
@@ -288,9 +269,6 @@ def panel(trans_id, is_query_tool, editor_title):
         url_params['did'] = trans_obj.did
         url_params['obj_id'] = trans_obj.obj_id
 
-    display_connection_status = pref.preference('connection_status').get()
-    queryToolShortcuts = get_query_tool_keyboard_shortcuts()
-
     return render_template(
         "datagrid/index.html",
         _=gettext,
@@ -300,19 +278,11 @@ def panel(trans_id, is_query_tool, editor_title):
         script_type_url=sURL,
         is_desktop_mode=app.PGADMIN_RUNTIME,
         is_linux=is_linux_platform,
-        is_new_browser_tab=new_browser_tab,
         server_type=server_type,
         client_platform=user_agent.platform,
         bgcolor=bgcolor,
         fgcolor=fgcolor,
-        # convert python boolean value to equivalent js boolean literal
-        # before passing it to html template.
-        prompt_save_changes='true' if prompt_save_changes else 'false',
-        display_connection_status=display_connection_status,
-        url_params=json.dumps(url_params),
-        key=queryToolShortcuts.get('keys'),
-        shortcuts=queryToolShortcuts.get('shortcuts'),
-        get_shortcut_text=get_text_representation_of_shortcut
+        url_params=json.dumps(url_params)
     )
 
 
@@ -387,13 +357,9 @@ def initialize_query_tool(sgid, sid, did=None):
     # Store the grid dictionary into the session variable
     session['gridData'] = sql_grid_data
 
-    pref = Preferences.module('sqleditor')
-    new_browser_tab = pref.preference('new_browser_tab').get()
-
     return make_json_response(
         data={
-            'gridTransId': trans_id,
-            'newBrowserTab': new_browser_tab
+            'gridTransId': trans_id
         }
     )
 
diff --git a/web/pgadmin/tools/datagrid/static/js/datagrid.js b/web/pgadmin/tools/datagrid/static/js/datagrid.js
index c730b180..bc66ba6d 100644
--- a/web/pgadmin/tools/datagrid/static/js/datagrid.js
+++ b/web/pgadmin/tools/datagrid/static/js/datagrid.js
@@ -29,6 +29,23 @@ define('pgadmin.datagrid', [
         this.initialized = true;
         this.title_index = 1;
 
+        /* Cache may take time to load for the first time
+         * Keep trying till available
+         */
+        let cacheIntervalId = setInterval(()=> {
+          this.preferences = pgBrowser.get_preferences_for_module('sqleditor');
+          if(this.preferences) {
+            clearInterval(cacheIntervalId);
+          }
+        });
+
+
+        let self = this;
+        pgBrowser.onPreferencesChange('sqleditor', function() {
+          self.preferences = pgBrowser.get_preferences_for_module('sqleditor');
+        });
+
+
         this.spinner_el = '<div class="wcLoadingContainer">'+
               '<div class="wcLoadingBackground"></div>'+
                 '<div class="wcLoadingIconContainer">'+
@@ -279,12 +296,12 @@ define('pgadmin.datagrid', [
                   lineNumbers: true,
                   mode: 'text/x-pgsql',
                   extraKeys: pgBrowser.editor_shortcut_keys,
-                  indentWithTabs: pgAdmin.Browser.editor_options.indent_with_tabs,
-                  indentUnit: pgAdmin.Browser.editor_options.tabSize,
-                  tabSize: pgBrowser.editor_options.tabSize,
-                  lineWrapping: pgAdmin.Browser.editor_options.wrapCode,
-                  autoCloseBrackets: pgAdmin.Browser.editor_options.insert_pair_brackets,
-                  matchBrackets: pgAdmin.Browser.editor_options.brace_matching,
+                  indentWithTabs: !this.preferences.use_spaces,
+                  indentUnit: this.preferences.tab_size,
+                  tabSize: this.preferences.tab_size,
+                  lineWrapping: this.preferences.wrap_code,
+                  autoCloseBrackets: this.preferences.insert_pair_brackets,
+                  matchBrackets: this.preferences.brace_matching,
                 });
 
                 setTimeout(function() {
@@ -415,13 +432,20 @@ define('pgadmin.datagrid', [
           }
         }
 
-        if (trans_obj.newBrowserTab) {
+        if (this.preferences.new_browser_tab) {
           var newWin = window.open(baseUrl, '_blank');
 
           // add a load listener to the window so that the title gets changed on page load
           newWin.addEventListener('load', function() {
             newWin.document.title = panel_title;
+
+            /* Set the initial version of pref cache the new window is having
+             * This will be used by the poller to compare with window openers
+             * pref cache version
+             */
+            newWin.pgAdmin.Browser.prefcache_version = pgBrowser.prefcache_version;
           });
+
         } else {
           /* On successfully initialization find the dashboard panel,
            * create new panel and add it to the dashboard panel.
